Bug 89130 - UI: Better UX for handling layer visibility and locking in the layer bar
Summary: UI: Better UX for handling layer visibility and locking in the layer bar
Status: NEW
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Draw (show other bugs)
Version:
(earliest affected)
unspecified
Hardware: All All
: medium enhancement
Assignee: Not Assigned
URL:
Whiteboard: target:6.0.0
Keywords: needsDevEval, topicUI
Depends on:
Blocks: Layers
  Show dependency treegraph
 
Reported: 2015-02-04 23:08 UTC by Rodolfo
Modified: 2018-04-08 09:08 UTC (History)
9 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Rodolfo 2015-02-04 23:08:15 UTC
I think there should be easier to change layer visibility and layer locking on Draw.

When creating/editing complex drawing, these feature are really useful, but by now one has to right-click the layer tab, choose a menu item to open a dialog, so you can (un)check these statuses and then click Ok. It is really annoying.

I propose a layer a bit wider with small icons to make these changes, like Gimp or Inkscape does.
Comment 1 V Stuart Foote 2015-02-05 13:51:28 UTC
@Rodolfo,

Great suggestion! So, how about doing a mock up?

As currently structured, layers are only applicable to Draw where we see the three default layers for every drawing--Layout, Controls, Dimension Lines--and any additional layers created show on that horizontal tab bar. Seeing the name of the layer on the tab bar is functional.

Would the simple change to a radio-button labeled with the layer name be enough? Maybe make the tabs moveable, i.e. order of sequence is order of layering? Could see function to that.

Or, does the UI need a rework? Replace the tab'd layer manger with a proper multi action dialog? Perhaps move to the Sidebar with a Tab and dedicated Content Panel?
 Then which button actions?

Visible/Hide (obvious)
Active layer (obvious)
Lock
Allow/disallow selection
...
Comment 2 Regina Henschel 2015-03-30 07:39:50 UTC
The current "shift-click" for toggling visibility might be extended for the other properties. For example Ctrl-click for toggling protection and alt-click for toggling printable. The status can be shown in the tab with font style italic for protected and inverse color for not printable.

You might want to follow the discussion in issue 90244, which is about enhancing the Navigator.
Comment 3 Yousuf Philips (jay) (retired) 2015-03-30 13:50:40 UTC
I was just about to submit a similar enhancement to include visibility and locking in the context menu of layers, so i do agree it needs to be more easily accessible.
Comment 4 QA Administrators 2015-12-27 20:31:24 UTC Comment hidden (obsolete, spam)
Comment 5 QA Administrators 2016-05-09 20:08:04 UTC Comment hidden (obsolete, spam)
Comment 6 Regina Henschel 2016-05-09 21:21:42 UTC
The design team or the UX team might discuss, which solution is the best. But at least my suggestion needs no further description and is a valid request.
Comment 7 Heiko Tietze 2016-05-09 22:37:11 UTC
Kind of duplicate to 56498 (and all similar tickets) but with some ideas here. Set component to Draw and keyword UX.
Comment 8 Yousuf Philips (jay) (retired) 2016-05-19 12:06:57 UTC
I believe this is covered in the enhancements to Navigator in bug 90244.
Comment 9 Yousuf Philips (jay) (retired) 2016-10-19 20:41:47 UTC
So lets leave this bug for toggling layer properties from the layer bar with click functionality like regina suggested in comment 2 and to add context menu entries for these options, as i mentioned in comment 4. If navigator gets redesigned (bug 90244) and the layer bar is removed, then this can be closed as WFM.
Comment 10 Ulrich Gemkow 2016-12-04 10:33:47 UTC
Would a patch implementing more layer attribute shortcuts according to comment#2 be accepted or is there some prior UX team discussion required?

I would propose a slight modification of the proposal in comment#2 because Mouse+Alt is used by Linux windows managers. We could use Shift+Ctrl instead.

Thanks.
Comment 11 Commit Notification 2017-09-04 00:11:00 UTC
Ulrich Gemkow committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=abe958a713ff0c26a3f91c558a2f227c1996c592

tdf#89130 Draw: Better UI for handling layer attributes

It will be available in 6.0.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 12 Xisco Faulí 2017-10-05 07:54:17 UTC
A polite ping to Ulrich Gemkow: is this bug fixed? if so, could you please close it as RESOLVED FIXED ? Thanks
Comment 13 Ulrich Gemkow 2017-10-05 17:24:26 UTC
(In reply to Xisco Faulí from comment #12)
> A polite ping to Ulrich Gemkow: is this bug fixed? if so, could you please
> close it as RESOLVED FIXED ? Thanks

I am not sure: The bug report with its comments has at least two aspects: Adding the shortcuts for changing layer attributes and adding a layer sidebar for more control. My patch only handles the first aspect.

Would it be correct to close this bug and open another bug for the sidebar aspect (which references this bug)?
Comment 14 Xisco Faulí 2017-10-05 20:59:27 UTC
(In reply to Ulrich Gemkow from comment #13)
> (In reply to Xisco Faulí from comment #12)
> > A polite ping to Ulrich Gemkow: is this bug fixed? if so, could you please
> > close it as RESOLVED FIXED ? Thanks
> 
> I am not sure: The bug report with its comments has at least two aspects:
> Adding the shortcuts for changing layer attributes and adding a layer
> sidebar for more control. My patch only handles the first aspect.
> 
> Would it be correct to close this bug and open another bug for the sidebar
> aspect (which references this bug)?

Yes, it's correct.
feel free to close this as RESOLVED FIXED and report a new one mentioning this one, either in the see also or in the description.
Comment 15 Yousuf Philips (jay) (retired) 2017-10-06 01:32:54 UTC
(In reply to Xisco Faulí from comment #14)
> Yes, it's correct.
> feel free to close this as RESOLVED FIXED and report a new one mentioning
> this one, either in the see also or in the description.

As mentioned in comment 9, "lets leave this bug for toggling layer properties from the layer bar with click functionality like regina suggested in comment 2 and to add context menu entries for these options, as i mentioned in comment 4", so this bug hasnt been fixed yet as the context menu entries havent been added.
Comment 16 Yousuf Philips (jay) (retired) 2018-01-17 01:11:30 UTC
Gulsah added a lock symbol to tabs in Calc (bug 95880), so it would be more useful to have that same UI in Draw and replace the various font styles to show the state with symbols which are more easily understood.
Comment 17 Ulrich Gemkow 2018-01-19 18:47:30 UTC
I could try to implement this, when this is the preferred way and accepted/wanted from the UI experts. But - who can draw/design the other two icons (for "not visible" and "not printable") besides the lock symbol which is used in calc? What is the "process" to "request" icons?

And the next question: In comment 9 a context menu in proposed for changing the layer attributes. Should the context menu be additional to the shortcuts or replace them? If this is in addition there would be three ways to achieve the same (dialog box, contex menu, shortcuts). Is this really wanted? Who can decide this?
Comment 18 Yousuf Philips (jay) (retired) 2018-01-20 14:13:09 UTC
(In reply to Ulrich Gemkow from comment #17)
> I could try to implement this, when this is the preferred way and
> accepted/wanted from the UI experts.

+1 from this UI expert. Heiko, Stuart: thoughts?

> But - who can draw/design the other two
> icons (for "not visible" and "not printable") besides the lock symbol which
> is used in calc? What is the "process" to "request" icons?

If i am reading Gulsah's and Eike's patches correctly, the lock symbol is being rendered from a font and not an icon.

> And the next question: In comment 9 a context menu in proposed for changing
> the layer attributes. Should the context menu be additional to the shortcuts
> or replace them?

Additional to the click shortcuts.

> If this is in addition there would be three ways to achieve
> the same (dialog box, contex menu, shortcuts). Is this really wanted? Who
> can decide this?

Yes this would be wanted, as only advanced users would know/remember the shortcuts. You can take my decision on this. The entries would need to be new UNO commands, so that they can appear in the context menu xml file.

https://opengrok.libreoffice.org/xref/core/sd/uiconfig/sdraw/popupmenu/layertab.xml
Comment 19 Yousuf Philips (jay) (retired) 2018-02-01 14:07:00 UTC
Maxim: Would it be possible to show click-based shortcuts for the UNO commands that would be added to the tab bar's context menu like Ctrl + Click?
Comment 20 Regina Henschel 2018-04-08 09:08:39 UTC
On Hackfest Hamburg, April 2018, we have decided to start a project for improving handling of layers and internal structure. In case you start to work on this issue get in contact with Regina (rb.henschel@t-online.de) or Armin (Armin.Le.Grand@me.com).